%%%% This is a demo file to show the use of the functions related to the
%%%% motif finding problem at first a dataset file is generated which contain
%%%% sequences having fixed GC fraction with planted motif in them. Then
%%%% mainFunction is used to find the motifs.



function [] = DEMO()
close all;
clear;
clc;

%%% Generate Synthetic Dataset
BackGroundLen = 200; % Background Length
GCFrac = 0.45; % GC Fraction
OutputFileName = '../MotifFindingEM/Dataset/Dataset1.txt'; % Output File naqme for dataset generation
Motif_Len = 15; % Motif Length
NumSeq = 25; % Number of sequence
NumMutations = 3; % Number of Mutations

% Generate Dataset
[TRUE_Motif] = GenerateDataset(OutputFileName,BackGroundLen,GCFrac,Motif_Len,NumSeq,NumMutations);

disp('Keep patience...');

InitialIterationInSearchSpace = 10; % Iteration # to intialise ALPHA_Init
Motif_Len = 15; % Motif Length
ALPHAInitLookAheadSTEP = 15; % # No of steps to look ahead during initialisation

mValueCBi = 1;  % # of Fork in Markov Chain
LengthOfMarkovChain = 100; % Markov chain length


%%%%%% Dataset File Name
inputFileName = '../MotifFindingEM/Dataset/Dataset1.txt';

%%%%% Call Main Function to Predict Motif
[PredictedMotif, PredictedMotifStartPositions]=mainFunction(Motif_Len,...
                                          inputFileName,InitialIterationInSearchSpace,...
                                          ALPHAInitLookAheadSTEP,mValueCBi,LengthOfMarkovChain);
  PredictedMotif
  PredictedMotifStartPositions;
end

