function [MOTIF4,D4] = mainFunction(Motif_Len,inputFileName, InitialIterationInSearchSpace, ALPHAInitLookAheadSTEP,mValueCBi,LengthOfMarkovChain)


ALPHABet='ATGC'; % DNA Alphabet

% Initialisation of different variables used in the proposed algorithm
BestQ4st = -1000;
ShiftFlag = 0;   
Alpha4Shift_counter = 0;    

%-----------------------------------------

pseudoCount = 0.1; % pseudocount to avoid zero count
Beta = 1.5/40 ; % initialize Beta overwrite later
GCFrac = 0.45; % GC Fraction

% Open Dataset File
fid = fopen(inputFileName); 
 

indx12=0;

%%% READ and PROCESS Dataset FILE
while 1
  tline = fgetl(fid);
  if ~ischar(tline), break, end
  indx12 = indx12+1;
  pat = '(?<Seq>[ATGC]*)\s*(?<MotifStartPosInBackground>\d+)\s*(?<MotifStartPosInTrueData>\d+)' ;
  tok = regexp(tline,pat, 'names');
  sequen = char(tok.Seq);
  MotifStartPosInBackground = str2double(char(tok.MotifStartPosInBackground));
  MotifStartPosInTrueData = str2double(char(tok.MotifStartPosInTrueData));
  SEQ_WITH_MOTIF_INSTANCE(indx12,:) = sequen;
  D_True(indx12) = MotifStartPosInBackground;
  BackGroundLen = length(sequen);
  clear tline;
end

NumSeq=indx12;
fclose(fid);


% Algo starts
tic;
Beta=1.5/NumSeq;

MC_Sample_Slice_Index3(1:NumSeq)=zeros;
MC_Sample_Slice_Index4(1:NumSeq)=zeros;



% Initialize Background Model
ALPHA0=[nnz(SEQ_WITH_MOTIF_INSTANCE=='A') nnz(SEQ_WITH_MOTIF_INSTANCE=='T') nnz(SEQ_WITH_MOTIF_INSTANCE=='G')  nnz(SEQ_WITH_MOTIF_INSTANCE=='C')];
% Normalise Background Model ALPHA0
ALPHA0=(ALPHA0+pseudoCount)/(sum(ALPHA0)+length(ALPHABet)*pseudoCount);



%%%%%%_____________________________________________________
%%%%%%%%%%%%%%%% Proposed Initialisation
    

for Iteration_Index=1:InitialIterationInSearchSpace
ALPHA_Init=rand(length(ALPHABet),Motif_Len);

[a3 b3]=size(ALPHA_Init);

% Normalise ALPHA_Init column wise
for normIndx=1:b3
    ALPHA_Init(:,normIndx)=ALPHA_Init(:,normIndx)/sum(ALPHA_Init(:,normIndx));
end

for itrToInitialize=1:ALPHAInitLookAheadSTEP
 Y3(1:NumSeq,1:(BackGroundLen-Motif_Len+1))=ones;
row=1;
for indx12=1:NumSeq
 
  %disp(tline);

  col=1;
  for indx=1:(BackGroundLen-Motif_Len+1)
      slice=SEQ_WITH_MOTIF_INSTANCE(indx12,(indx:indx+Motif_Len-1));
      segment(row,col,1:Motif_Len)=slice;
      %Y3(row,col)=1;
    
    %%%%%%%%%%%%% Update Y3 using ALPHA3
   if itrToInitialize > 1
    for segIndx=1:Motif_Len
      if segment(row,col,segIndx)=='A'
          Y3(row,col)=Y3(row,col)*ALPHA_Init(1,segIndx)/ALPHA0(1);
      end
      if segment(row,col,segIndx)=='T'
          Y3(row,col)=Y3(row,col)*ALPHA_Init(2,segIndx)/ALPHA0(2);
      end
      if segment(row,col,segIndx)=='G'
          Y3(row,col)=Y3(row,col)*ALPHA_Init(3,segIndx)/ALPHA0(3);
      end
      if segment(row,col,segIndx)=='C'
          Y3(row,col)=Y3(row,col)*ALPHA_Init(4,segIndx)/ALPHA0(4);
      end    
    end   
   end
         
      col=col+1;
  end
  row=row+1;
end
 
for normIndx=1:NumSeq
   
    Y3(normIndx,:)=Y3(normIndx,:)/sum(Y3(normIndx,:));
end
 [S D]=max(Y3,[],2);
 

% For Probabilistic Look Ahead
for indx123=1:NumSeq
 MC_Sample_Slice_Index3(indx123) = SamplingAccordingToPMF(Y3(indx123,:), 1);
end


    %%% ***** Update ALPHA_Init
    ALPHA_Init(1:length(ALPHABet),1:Motif_Len)=zeros;  
        %%% *****
       for idx2row=1:NumSeq
             
                  for indx7=1:Motif_Len
                      
                      if segment(idx2row,MC_Sample_Slice_Index3(idx2row),indx7)=='A'
                          ALPHA_Init(1,indx7)=ALPHA_Init(1,indx7)+ 1;
                      end
                      
                      if segment(idx2row,MC_Sample_Slice_Index3(idx2row),indx7)=='T'
                          ALPHA_Init(2,indx7)=ALPHA_Init(2,indx7)+ 1;
                      end
                      
                      if segment(idx2row,MC_Sample_Slice_Index3(idx2row),indx7)=='G'
                          ALPHA_Init(3,indx7)=ALPHA_Init(3,indx7)+ 1;
                      end
                      
                      if segment(idx2row,MC_Sample_Slice_Index3(idx2row),indx7)=='C'
                          ALPHA_Init(4,indx7)=ALPHA_Init(4,indx7)+ 1;
                      end
                      
                  end             
       end

% Add Pseudo-count
ALPHA_Init=ALPHA_Init + Beta * ones;
[a b]=size(ALPHA_Init);

% Normalise ALPHA column wise
for normIndx=1:b
   
    ALPHA_Init(:,normIndx)=ALPHA_Init(:,normIndx)/sum(ALPHA_Init(:,normIndx));
end
 Q31(Iteration_Index)=0;
  for indexa=1:a
      for indexb=1:b
          Q31(Iteration_Index)=Q31(Iteration_Index)+ ALPHA_Init(indexa,indexb)* log10(ALPHA_Init(indexa,indexb));
      end  
  end
 end
  ALPHA_Init_Copy(Iteration_Index,1:length(ALPHABet),1:Motif_Len)= ALPHA_Init;
end

    %%% Find Max Q
     [x1 y1]=max(Q31,[],2);
     ALPHA4(:,:)=ALPHA_Init_Copy(y1,:,:);
     

  %%%%%%%%%%%%% END Initialisation
%%%%%%%--------------------------------------------------------

% Interate to generate Markov chain

for Iteration_Index=1:LengthOfMarkovChain
Y4(1:NumSeq,1:(BackGroundLen-Motif_Len+1))=ones;
row=1;
for indx12=1:NumSeq

  col=1;
  for indx=1:(BackGroundLen-Motif_Len+1)
      slice=SEQ_WITH_MOTIF_INSTANCE(indx12,(indx:indx+Motif_Len-1));
      segment(row,col,1:Motif_Len)=slice;
     
        %%%%%%%%%%%%% Update Y4 using ALPHA4
    for segIndx=1:Motif_Len
      if segment(row,col,segIndx)=='A'
          Y4(row,col)=Y4(row,col)*ALPHA4(1,segIndx)/ALPHA0(1);
      end
      if segment(row,col,segIndx)=='T'
          Y4(row,col)=Y4(row,col)*ALPHA4(2,segIndx)/ALPHA0(2);
      end
      if segment(row,col,segIndx)=='G'
          Y4(row,col)=Y4(row,col)*ALPHA4(3,segIndx)/ALPHA0(3);
      end
      if segment(row,col,segIndx)=='C'
          Y4(row,col)=Y4(row,col)*ALPHA4(4,segIndx)/ALPHA0(4);
      end    
    end
    
       
      col=col+1;
  end
  row=row+1;
end


%%%%%%%%%  Normalize  Y4

for normIndx=1:NumSeq
   
    Y4(normIndx,:)=Y4(normIndx,:)/sum(Y4(normIndx,:));
end
  
 % Best Q4 Initialisation
 BestQ4=-10000;
 BestALPHA4(1:length(ALPHABet),1:Motif_Len)=zeros; 
  
MC_Sample_Slice_Index4(1:NumSeq)=zeros; 

for ItrForBestQ=1:mValueCBi
% Sample according to distribution

for indx123=1:NumSeq
 MC_Sample_Slice_Index4(indx123) = SamplingAccordingToPMF(Y4(indx123,:), 1);
end

 %%%%%%%%%% Update ALPHA4 
 %  A T G C  % ********
 ALPHA4(1:length(ALPHABet),1:Motif_Len)=zeros;  
 
 
   %%% ***** Update ALPHA4
        %%% *****
       for idx2row=1:NumSeq
             
                  for indx7=1:Motif_Len
                      
                      if segment(idx2row,MC_Sample_Slice_Index4(idx2row),indx7) == 'A'
                          ALPHA4(1,indx7) = ALPHA4(1,indx7) + 1;
                      end
                      
                      if segment(idx2row,MC_Sample_Slice_Index4(idx2row),indx7) == 'T'
                          ALPHA4(2,indx7) = ALPHA4(2,indx7) + 1;
                      end
                      
                      if segment(idx2row,MC_Sample_Slice_Index4(idx2row),indx7) == 'G'
                          ALPHA4(3,indx7) = ALPHA4(3,indx7) + 1;
                      end
                      
                      if segment(idx2row,MC_Sample_Slice_Index4(idx2row),indx7) == 'C'
                          ALPHA4(4,indx7) = ALPHA4(4,indx7) + 1;
                      end
                      
                  end
              
       end     

% Add Pseudo-count

ALPHA4=ALPHA4 + Beta * ones;
[a4 b4] = size(ALPHA4);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%%%%%%% ALPHA4 SHIFTING MECHANISM
%with probability .5
%Alpha4Shift_counter=0;
%%% we can modify the probability according to Q value
if (mod(randi(100),11) == 1)&&(Alpha4Shift_counter == 0)&&(Iteration_Index < LengthOfMarkovChain-10)
    ShiftFlag = 1;
    BestQ_stored = BestQ4st;
    ALPHA4_stored = ALPHA4;
    Alpha4Shift_counter = 0;
   if mod(randi(100),2) == 1
      ALPHA4(:, 2:b4) = ALPHA4(:, 1:b4-1);
      ALPHA4(:,1) = rand(a4,1);
   else
      ALPHA4(:, 1:b4-1) = ALPHA4(:, 2:b4);
      ALPHA4(:,b4) = rand(a4,1);
   end
end

if (ShiftFlag==1)
Alpha4Shift_counter = Alpha4Shift_counter+1;
end
if (Alpha4Shift_counter == 3)&&(ShiftFlag == 1)
    ShiftFlag=0;
    Alpha4Shift_counter = 0;
   if BestQ_stored > BestQ4st
       ALPHA4 = ALPHA4_stored;
       BestQ4st = BestQ_stored;
       
   end

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  % Normalise ALPHA4 column wise
for normIndx = 1:b4
   
    ALPHA4(:,normIndx) = ALPHA4(:,normIndx)/sum(ALPHA4(:,normIndx));
end

  
  % Calculate Q4 Function : Goodness Measure 
  Q4=0;
  for indexa = 1 : a4
      for indexb = 1 : b4
          Q4=Q4+ ALPHA4(indexa,indexb)* log10(ALPHA4(indexa,indexb));
      end  
  end
  if BestQ4 < Q4
      BestQ4 = Q4;
      BestALPHA4 = ALPHA4;
  end
  
end  %% End of for ItrForBestQ






%%%%%%%%%% shifted ALPHA4
ALPHA4 = BestALPHA4;
BestQ4st = BestQ4;

  % Normalise ALPHA4 column wise
for normIndx = 1 : b4
    ALPHA4(:,normIndx) = ALPHA4(:,normIndx)/sum(ALPHA4(:,normIndx));
end

end



% Find The best Motif
[S4 D4]=max(Y4,[],2);
[F4 SEQindices]=max(ALPHA4,[],1);

for i=1:Motif_Len
    if SEQindices(i)==1
        MOTIF4(i) = 'A';
    end
     if SEQindices(i)==2
        MOTIF4(i) = 'T';
     end
     if SEQindices(i)==3
        MOTIF4(i) = 'G';
     end
     if SEQindices(i)==4
        MOTIF4(i) = 'C';
     end
end

toc
end



